#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "adm670.h"

#define	FIFO_CHKTIME	5000

void close(void);
void status_chk(WORD expect, WORD mask, char *message);
void timer_chk(void);
void counter_chk(void);
int  clock_count(int msec);
int data_count(int msec);
void full_sample(void);
void fifo_count(void);
BOOL wait_flag(int flag);
void intr_flag_chk(void);
void testflag (void);

int resource_no;

void main(void)
{
	int	i, j, brd_num, rv, device_id[8], index[8];
	WORD data;
	DWORD start_time;
	BOOL quit, err;

	printf("ADM-670PCI mFvOV1.3\n");
	// RQDVUWlg쎞̃JE^lϓ}邽߁A{[hZbgǉ 11/July/2012

	for (i = 0; i <= 7; i++)
	{
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0)
	{
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0)
	{
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);

	for (i = 0; i < brd_num; i++)
	{
		printf("%dڂ̃{[h̃`FbN܂B\n", i + 1);
		rv = Start_Driver(index[i], 2, &resource_no);
		if (rv != 0)
		{
			printf("Open_DriverŃG[(%d)܂B\n", rv);
			close();
		}

		data = ReadWord(resource_no, RESET);
		if (data == BOARD_ID)
			printf("{[hID(=%02xH)͐ŁA", data);
		else
		{
			printf("{[hID(=%02xH)ُ͈łB\n", data);
			close();
		}

		data = ReadWord(resource_no, BRDNUM);
		printf("{[hԍݒ(%d)łB\n", data & 0x0f);

		status_chk(0x0002, 0x07ff, "Zbg̃Xe[^X");

		// `lPɐݒ
		WriteWord(resource_no, CHNUM, BP10 + 0);

		// P}jAETvOs
		ReadWord(resource_no, MANUAL);
		wait_flag(NOT_EMPTY);
		status_chk(0x0083, 0x07ff, "}jAETvÕXe[^X");

		// eheñf[^ǂݏo
		ReadWord(resource_no, DATA);
		status_chk(0x0082, 0x07ff, "f[^ǂݎ̃Xe[^X");

		// ^C}[̃`FbbN
		timer_chk();

		// {[hEZbg
		ReadWord(resource_no, RESET);

		// Xg܂ŃTvOB
		full_sample();

		status_chk(0x00b5, 0x05ff, "TvÕXe[^X");

		// m̃tÕNA
		WriteWord(resource_no, STSCLR, END_FLAG | EOS_FLAG | CLOCK_FLAG | LOST_ERR);
		status_chk(0x0011, 0x07ff, "tOENÃXe[^X");

		WriteWord(resource_no, TRIG, 0);	// TRG_FLAG̃NA
		status_chk(0x0001, 0x07ff, "gK֎~̃Xe[^X");

		// ehenTCY̌v
		fifo_count();

		data = ReadWord(resource_no, STATUS) & 0x07ff;
		printf("tO(%04xH)łB\n", data);

		// _JE^̃`FbbN
		counter_chk();

//		status_chk(0x0002, "NAEtOiEOS)̃Xe[^X");

		// 荞݃tÕ`FbN
//		intr_flag_chk();
//		testflag ();

		rv = Stop_Driver(resource_no);
		if (rv != 0)
		{
			printf("Stop_DriverŃG[(%d)܂B\n", rv);
			close();
		}
	}
	close();
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0)
	{
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}

void status_chk(WORD expect, WORD mask, char *message)
{
	WORD data;

	data = ReadWord(resource_no, STATUS) & 0xfeff;		// RQlKehenł̓[AbvtO
	printf("%s(%04xH)", message, data);				// ZbgĂ܂߁AYrbg폜
	printf(((data & mask) == expect) ? "łB\n" : "ُłB\n");
	if ((data & mask) != expect)
		printf("	Ғl(%04xH)łB\n" , expect);
	else
		;
}

void timer_chk(void)
{
	int clk_num, data_num;
	
	// SOlggpĂPOgɐݒ
	WriteWord(resource_no, CLKSEL, INT_40M);
	WriteWord(resource_no, CLKDIV, 0x0900);	// WORD
	WriteWord(resource_no, CLKDIV, 0x003d);	// WORD	

	// `lPɐݒ
	WriteWord(resource_no, CHNUM, BP10 + 0);

	printf("SOlg");
	clk_num = clock_count(1020);
	data_num = data_count(1000);

	printf("NbN(%ld)Af[^(%ld)", clk_num, data_num);
	printf(((clk_num == 11) && (data_num == 11)) ? "łB\n" : "\n	ُłB\n");

	status_chk(0x0082, 0x00ff, "Xe[^X");
		ReadWord(resource_no, RESET);
	// RQDVUWlggpĂPOgɐݒ
	WriteWord(resource_no, CLKSEL, INT_32M);
	WriteWord(resource_no, CLKDIV, 0x0000);	// WORD
	WriteWord(resource_no, CLKDIV, 0x0032);	// WORD	

	printf("RQDVUWlg");
	clk_num = clock_count(1020);
	data_num = data_count(1000);

	printf("NbN(%ld)Af[^(%ld)", clk_num, data_num);
	printf(((clk_num == 11) && (data_num == 11)) ? "łB\n" : "\n	ُłB\n");

}

void counter_chk(void)
{
	int data_num;
	DWORD start_time;
	BOOL quit;
	
	// SOlggpĂPlgɐݒ
	WriteWord(resource_no, CLKSEL, INT_40M);
	WriteWord(resource_no, CLKDIV, 0x0040);	// WORD
	WriteWord(resource_no, CLKDIV, 0x0000);	// WORD	

	// _JE^100ɐݒ
	WriteWord(resource_no, POST_CNT, 100);	// WORD
	WriteWord(resource_no, POST_CNT, 0);	// WORD	

	// `lPɐݒ
	WriteWord(resource_no, CHNUM, BP10 + 0);

	// \tgEgKݒiX^[gj
	WriteWord(resource_no, TRIG, SOFT_TRIG);

	// |XggKLTvOŊJn
	WriteWord(resource_no, START, POST_START);

	// dmctO҂
	printf("JE^̃eXgDDD");
	printf((wait_flag(END_FLAG) ? "I܂B\n" : "^CAEg܂B\n"));

	data_num = data_count(1000);

	printf("f[^(%ld)", data_num);
	printf((data_num == 100) ? "łB\n" : "ُłB\n");

}

int clock_count(int msec)
{
	int i;
	DWORD start_time;
	BOOL quit;

	// `lPɐݒ
	WriteWord(resource_no, CHNUM, BP10 + 0);

	// \tgEgKݒiX^[gj
	WriteWord(resource_no, TRIG, SOFT_TRIG);

	printf("NbÑeXgDDD");
	start_time = GetTickCount();
	// |XggKTvOŊJn
	WriteWord(resource_no, START, POST_CONT_START);
	i = 0;
	quit = FALSE;
	do {
		if ((ReadWord(resource_no, STATUS) & CLOCK_FLAG) == CLOCK_FLAG) {
			++i;
			// NbNEtÕNA
			WriteWord(resource_no, STSCLR, CLOCK_FLAG);
		}
		else if ((start_time + msec) < GetTickCount()) {	// TvO~
			WriteWord(resource_no, START, STOP);
			printf("I܂B\n");
			quit = TRUE;
		}
	} while (quit == FALSE);
	return (i);
}

int data_count(int msec)
{
	int count;
	DWORD start_time;
	BOOL quit;

	start_time = GetTickCount();
	count = 0;
	quit = FALSE;
	do {
		ReadWord(resource_no, DATA);
		++count;
		if ((ReadWord(resource_no, STATUS) & NOT_EMPTY) != NOT_EMPTY)
			quit = TRUE;
		else if ((start_time + msec) < GetTickCount())
		{
			count = -1;
			quit = TRUE;
		}
	}  while (quit == FALSE);

	return (count);
}

void full_sample(void)
{
	int ch;
	DWORD start_time;
	BOOL quit;

	// `lSɐݒ
	for (ch = 0; ch < MAX_CH; ch++)
		WriteWord(resource_no, CHNUM, (unsigned short)(BP10 + ch));

	// NbNPlgɐݒ
	WriteWord(resource_no, CLKSEL, INT_40M);
	WriteWord(resource_no, CLKDIV, 40);	// WORD
	WriteWord(resource_no, CLKDIV, 0);	// WORD	

	// \tgEgKݒiX^[gj
	WriteWord(resource_no, TRIG, SOFT_TRIG);

	// |XggKTvOŊJn
	WriteWord(resource_no, START, POST_CONT_START);

	// f[^EXg҂
	printf("TvODDD");
	printf((wait_flag(LOST_ERR) ? "I܂B\n" : "^CAEg܂B\n"));

	// TvO~
	WriteWord(resource_no, START, STOP);
}

void fifo_count(void)
{
	int j, half_size, full_size, old_j;
	DWORD start_time;
	BOOL quit, not_reported;

	printf("ehenJEgDDD");
	start_time = GetTickCount();
	j = 0;
	quit = FALSE;
	not_reported = FALSE;
	old_j = j;
	do {
		ReadWord(resource_no, DATA);
		++j;
		if ((ReadWord(resource_no, STATUS) & NOT_HALF) == NOT_HALF)
			quit = TRUE;
		else if ((start_time + FIFO_CHKTIME) < GetTickCount()){
			if ( j == old_j){
				printf("^CAEg܂B\n");
				quit = TRUE;
			}
			else if (not_reported == FALSE){
				not_reported = TRUE;
				start_time = GetTickCount();
				old_j = j;
				quit = FALSE;
				printf("\nKehen`FbNȂ̂ŁA΂炭ԂKvłB\n");
			}
			else {
				start_time = GetTickCount();
				old_j = j;
				quit = FALSE;
				printf("D");
			}
		}
		else
			;
	}  while (quit == FALSE);

	half_size = data_count(10000);
	full_size = j + half_size;
	
	printf("I܂B\n");
	printf("FULL =i%ld) HALF = (%ld)łB\n", full_size, half_size);
}

BOOL wait_flag(int flag)
{
	DWORD start_time;

	start_time = GetTickCount();
	while (1)
	{
		if ((ReadWord(resource_no, STATUS) & flag) == flag)
			return TRUE;
		else if (start_time + FIFO_CHKTIME < GetTickCount()){
			start_time = GetTickCount();
			printf("D");
		}
		else
			;
	}
}

void intr_flag_chk(void)
{
	int ch;
	WORD data;
	DWORD start_time;
	BOOL quit;

	// {[hEZbg
	ReadWord(resource_no, RESET);

	// `lSɐݒ
	for (ch = 0; ch < MAX_CH; ch++)
		WriteWord(resource_no, CHNUM, (unsigned short)(BP10 + ch));

	// NbNPlgɐݒ
	WriteWord(resource_no, CLKSEL, INT_40M);
	WriteWord(resource_no, CLKDIV, 40);	// WORD
	WriteWord(resource_no, CLKDIV, 0);	// WORD	

	// _JE^100ɐݒ
	WriteWord(resource_no, POST_CNT, 0x1000);	// WORD
	WriteWord(resource_no, POST_CNT, 0);	// WORD	

	// \tgEgKݒiX^[gj
	WriteWord(resource_no, TRIG, SOFT_TRIG);

	// |XggKLTvOŊJn
	WriteWord(resource_no, START, POST_START);

	// 荞ݗv̎w肨ы
	WriteWord(resource_no, INTRSRC, INTR_CLOCK);
//	WriteWord(resource_no, INTRSRC, 0);
	WriteWord(resource_no, INTROUT, INTR_EN);

	// 荞ݗvtO҂
	printf("gK݌oDDD");
	printf((wait_flag(INTR_FLAG) ? "o܂B\n" : "^CAEg܂B\n"));

	data = ReadWord(resource_no, STATUS) & 0x07ff;
	printf("tO(%04xH)łB\n", data);

	// TvO~
	WriteWord(resource_no, START, STOP);

	// 荞݋֎~
	WriteWord(resource_no, INTROUT, INTR_DIS);
}

void testflag (void)
{
	int		i;
	int		clk,smplnum;
	int		status;

	clk = 400;
	smplnum= 4096;

	ReadWord ( resource_no, 0xe );

	WriteWord ( resource_no, 0 , 0 );

	WriteWord ( resource_no, 0x12, 0 );			/* ۯӰ޾	 */

	WriteWord ( resource_no, 0x14 , (unsigned short)(clk & 0xffff)); 				/* ۯ */
	WriteWord ( resource_no, 0x14 ,(unsigned short)((clk >> 16) & 0xffff));		 	/* ۯ */

	WriteWord ( resource_no, 0x16 , (unsigned short)(smplnum & 0xffff));			/*smplnum*/
	WriteWord ( resource_no, 0x16 ,(unsigned short)((smplnum >> 16) & 0xffff));		/*smplnum*/

	WriteWord ( resource_no, 0x10, 0x1);
	WriteWord ( resource_no, 0x2, 0x1);

	WriteWord ( resource_no, 0x8, 0x4 );			/* ݸޥ */
	WriteWord ( resource_no, 0x6, 0x80);			/* ضӰ޾	 */

	status = ReadWord ( resource_no, 0xA);
	printf ( "Input.data = %x \n", status);
	getch();

	while (!(0x200 == (status = ReadWord (resource_no, 0xA ) & 0x200))){
		printf ( "Input.data = %x \n", status);
				}

	status = ReadWord ( resource_no, 0xA);
	printf ( "Input.data = %x \n", status);

	WriteWord ( resource_no, 0x8, 0x0 );			/* ݸޥstop */
	WriteWord ( resource_no, 0x6, 0x0 );			/* ضӰ stop	 */

	status = ReadWord ( resource_no, 0xA);
	printf ( "Input.data = %x \n", status);

	WriteWord ( resource_no, 0xA , 0x2b4);
	status = ReadWord ( resource_no, 0xA);
	printf ( "Input.data = %x \n", status);

}

