#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "port_2k.h"
#include "adm686.h"

#define	FIFO_CHKTIME	5000

void close(void);
void status_chk(BYTE expect, BYTE mask, char *message);
void timer_chk(void);
int  clock_count(int msec);
int data_count(int msec);
void full_sample(void);
void fifo_count(void);
BOOL wait_flag(int flag);
void intr_flag_chk(void);

int resource_no;
int	Z_flag = FALSE;

void main(void)
{
	int	i, j, brd_num, rv, device_id[8], index[8];
	BYTE data;
	DWORD start_time;
	BOOL quit, err;

	printf("ADM-686PCI mFvOV1.3\n");
	// RQDVUWlg쎞̃JE^lϓ}邽߁A{[hZbgǉ 11/July/2012

	for (i = 0; i <= 7; i++)
	{
		device_id[i] = -1;
		index[i] = -1;
	}

	brd_num = 0;
	rv = Open_Driver(device_id);
	if (rv != 0)
	{
		printf("Open_DriverŃG[(%d)܂B\n", rv);
		exit (-1);
	}

	for (i = 0; i <= 7; i++)
		if (DEVICE_ID ==device_id[i])
			index[brd_num++] = i;

	if (brd_num == 0)
	{
		printf("%soł܂B\n", BOARD_NAME);
		close();
	}
	else
		printf("%s%do܂B\n", BOARD_NAME, brd_num);

	for (i = 0; i < brd_num; i++)
	{
		printf("%dڂ̃{[h̃`FbN܂B\n", i + 1);
		rv = Start_Driver(index[i], 2, &resource_no);
		if (rv != 0)
		{
			printf("Open_DriverŃG[(%d)܂B\n", rv);
			close();
		}

		data = ReadByte(resource_no, RESET);
		if (data == BOARD_ID)
			printf("{[hID(%02xH)͐ŁA", data);
		else
		{
			printf("{[hID(=%02xH)ُ͈łB\n", data);
			close();
		}

		data = ReadByte(resource_no, BRDNUM);
		printf("{[hԍݒ(%d)łB\n", data & 0x0f);

		status_chk(0x0002, 0x00ff, "Zbg̃Xe[^X");

		// `lPɐݒ
		WriteByte(resource_no, CHNUM, 0);

		// P}jAETvOs
		ReadByte(resource_no, MANUAL);
		wait_flag(NOT_EMPTY);
		status_chk(0x0083, 0x00ff, "}jAETvÕXe[^X");

		// eheñf[^ǂݏo
		ReadByte(resource_no, DATA);	// ʃoCh
		ReadByte(resource_no, DATA);	// ʃoCg
		status_chk(0x0082, 0x00ff, "f[^ǂݎ̃Xe[^X");

		// ^C}[̃`FbbN
		timer_chk();

		// {[hEZbg
		ReadByte(resource_no, RESET);

		// Xg܂ŃTvOB
		full_sample();

		status_chk(0x00a5, 0x00ff, "TvÕXe[^X");

		// m̃tÕNA
		if (Z_flag == FALSE)
			WriteByte(resource_no, STSCLR, EOS_FLAG | CLOCK_FLAG | SMP_ERR);
		else
			WriteByte(resource_no, STSCLR, EOS_FLAG | CLOCK_FLAG | SMP_ERR | 0x08 );
		status_chk(0x0001, 0x00ff, "tOENÃXe[^X");

		// ehenTCY̌v
		fifo_count();

		data = ReadByte(resource_no, STATUS) & 0xfe;
		printf("tO(%02xH)łB\n", data);

//		status_chk(0x0002, "NAEtOiEOS)̃Xe[^X");

		// 荞݃tÕ`FbN
//		intr_flag_chk();

		rv = Stop_Driver(resource_no);
		if (rv != 0)
		{
			printf("Stop_DriverŃG[(%d)܂B\n", rv);
			close();
		}
	}
	close();
}

void close()
{
	int rv;
	
	rv = Close_Driver();
	if (rv != 0)
	{
		printf("Close_DriverŃG[(%d)܂B\n", rv);
	}
	exit(-1);
}

void status_chk(BYTE expect, BYTE mask, char *message)
{
	BYTE data;

	data = ReadByte(resource_no, STATUS);
	if ( data & 0x08 ){
		Z_flag |= TRUE;
		data = data & ~0x08;					/* Mask ADM-686z's flag */
	}
	else
		;
	printf("%s(%02xH)", message, data);
	printf(((data & mask) == expect) ? "łB\n" : "ُłB\n");
	if ((data & mask) != expect)
		printf("	Ғl(%04xH)łB\n" , expect);
	else
		;
}

void timer_chk(void)
{
	int clk_num, data_num;
	
	// POlggpĂPOgɐݒ
	WriteByte(resource_no, CLKSEL, INT_10M);
	WriteByte(resource_no, CLKDIV, 0xe8);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x03);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0xe8);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x03);	// JE^aBYTE

	// `lPɐݒ
	WriteByte(resource_no, CHNUM, 0);

	printf("POlg");
	clk_num = clock_count(1020);
	data_num = data_count(1000);

	printf("NbN(%ld)Af[^(%ld)", clk_num, data_num);
	printf(((clk_num == 11) && (data_num == 11)) ? "łB\n" : "\n	ُłB\n");

	status_chk(0x0082, 0x00ff, "Xe[^X");
		ReadWord(resource_no, RESET);
	// WDPXQlggpĂPOgɐݒ
	WriteByte(resource_no, CLKSEL, INT_8M);
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x04);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x20);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x03);	// JE^aBYTE

	printf("WDPXQlg");
	clk_num = clock_count(1020);
	data_num = data_count(1000);

	printf("NbN(%ld)Af[^(%ld)", clk_num, data_num);
	printf(((clk_num == 11) && (data_num == 11)) ? "łB\n" : "\n	ُłB\n");

}

int clock_count(int msec)
{
	int i;
	DWORD start_time;
	BOOL quit;

	// `lPɐݒ
	WriteByte(resource_no, CHNUM, 0);

	printf("NbÑeXgDDD");
	start_time = GetTickCount();
	// \tgEgKݒiX^[gj
	WriteByte(resource_no, TRIG, SOFT_TRIG);
	i = 0;
	quit = FALSE;
	do {
		if ((ReadByte(resource_no, STATUS) & CLOCK_FLAG) == CLOCK_FLAG) {
			++i;
			// NbNEtÕNA
			WriteByte(resource_no, STSCLR, CLOCK_FLAG);
		}
		else if ((start_time + msec) < GetTickCount()) {	// TvO~
			WriteByte(resource_no, TRIG, STOP);
			printf("I܂B\n");
			quit = TRUE;
		}
	} while (quit == FALSE);
	return (i);
}

int data_count(int msec)
{
	int count;
	DWORD start_time;
	BOOL quit;

	start_time = GetTickCount();
	count = 0;
	quit = FALSE;
	do {
		ReadByte(resource_no, DATA);	// ʃoCg
		ReadByte(resource_no, DATA);	// ʃoCg
		++count;
		if ((ReadByte(resource_no, STATUS) & NOT_EMPTY) != NOT_EMPTY)
			quit = TRUE;
		else if ((start_time + msec) < GetTickCount())
		{
			count = -1;
			quit = TRUE;
		}
	}  while (quit == FALSE);

	return (count);
}

void full_sample(void)
{
	int ch;
	DWORD start_time;
	BOOL quit;

	// `lPUɐݒ
	WriteByte(resource_no, CHNUM, MAX_CH - 1);

	// NbNRDPQTjgiRQOʂrjɐݒ
	WriteByte(resource_no, CLKDIV, 0x80);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x0c);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x01);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE

	// \tgEgKݒiX^[gj
	WriteByte(resource_no, TRIG, SOFT_TRIG);

	// f[^EXg҂
	printf("TvODDD");
	printf((wait_flag(SMP_ERR) ? "I܂B\n" : "^CAEg܂B\n"));

	// TvO~
	WriteByte(resource_no, TRIG, STOP);
}

void fifo_count(void)
{
	int j, half_size, full_size, old_j;
	DWORD start_time;
	BOOL quit, not_reported;

	printf("ehenJEgDDD");
	start_time = GetTickCount();
	j = 0;
	quit = FALSE;
	not_reported = FALSE;
	old_j = j;
	do {
		ReadByte(resource_no, DATA);	// ʃoCg
		ReadByte(resource_no, DATA);	// ʃoCg
		++j;
		if ((ReadByte(resource_no, STATUS) & NOT_HALF) == NOT_HALF)
			quit = TRUE;
		else if ((start_time + FIFO_CHKTIME) < GetTickCount()){
			if ( j == old_j){
				printf("^CAEg܂B\n");
				quit = TRUE;
			}
			else if (not_reported == FALSE){
				not_reported = TRUE;
				start_time = GetTickCount();
				old_j = j;
				quit = FALSE;
				printf("\nKehen`FbNȂ̂ŁA΂炭ԂKvłB\n");
			}
			else {
				start_time = GetTickCount();
				old_j = j;
				quit = FALSE;
				printf("D");
			}
		}
		else
			;
	}  while (quit == FALSE);

	half_size = data_count(10000);
	full_size = j + half_size;
	
	printf("I܂B\n");
	printf("FULL =i%ld) HALF = (%ld)łB\n", full_size, half_size);
}

BOOL wait_flag(int flag)
{
	DWORD start_time;

	start_time = GetTickCount();
	while (1)
	{
		if ((ReadByte(resource_no, STATUS) & flag) == flag)
			return TRUE;
		else if (start_time + FIFO_CHKTIME < GetTickCount()){
			start_time = GetTickCount();
			printf("D");
		}
		else
			;
	}
}

void intr_flag_chk(void)
{
	int ch;
	BYTE data;
	DWORD start_time;
	BOOL quit;

	// {[hEZbg
	ReadByte(resource_no, RESET);

	// `lPUɐݒ
	WriteByte(resource_no, CHNUM, MAX_CH - 1);

	// NbNRDPQTjgiRQOʂrjɐݒ
	WriteByte(resource_no, CLKDIV, 0x80);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x0c);	// JE^`BYTE
	WriteByte(resource_no, CLKDIV, 0x01);	// JE^aBYTE
	WriteByte(resource_no, CLKDIV, 0x00);	// JE^aBYTE

	// \tgEgKݒiX^[gj
	WriteByte(resource_no, TRIG, SOFT_TRIG);

	// 荞ݗv̎w肨ы
	WriteByte(resource_no, INTRSRC, INTR_CLOCK);
	WriteByte(resource_no, INTROUT, INTR_EN);

	// 荞ݗvtO҂
	printf("gK݌oDDD");
	printf((wait_flag(INTR_FLAG) ? "o܂B\n" : "^CAEg܂B\n"));

	data = ReadByte(resource_no, STATUS) & 0x0ef;
	printf("tO(%04xH)łB\n", data);

	// TvO~
	WriteByte(resource_no, TRIG, STOP);

	// 荞݋֎~
	WriteByte(resource_no, INTROUT, INTR_DIS);
}

